/* cdcnv.c -------------------------------------
  ( rcctl.c )
  v0.30  97.12.13  Ѵ(cdcnv.c)ʬΥ
----------------------------------------------*/

#include <string.h>
#if defined(__FreeBSD__)||defined(linux)
#define stricmp(s, c) strcasecmp(s, c)
#endif

const char *mks = "XUGJBPDAZT";
#define M_X2 0
#define M_UK 1
#define M_GI 2
#define M_JO 3
#define M_BT 4
#define M_PR 5
#define M_DA 6
#define M_AL 7
#define M_AZ 8
#define M_TS 9

#define K_SE 3
#define K_KU 4
#define K_KD 5
#define K_SP 6
#define K_ST 7
#define K_CL 8
#define K_NM 9

int cvt[][21] = {
  /* cd,  IDL,  IDH,   SE,   KU,   KD,   SP,   ST,   CL, */
  /*  0,    1,    2,    3,    4,    5,    6,    7,    8,    9,    A,    B*/
  {0x30, 0x2e, 0xd1, 0x17, 0x02, 0x03, 0x0c, 0x1c, 0x0d,         /* X2000 */
   0x13, 0x10, 0x14, 0x18, 0x11, 0x15, 0x19, 0x12, 0x16, 0x1a,   -1,   -1 },
  {0x30, 0x98, 0x67, 0x0c, 0x13, 0x12, 0x0f, 0x0e, 0x0d,     /* U-kara/-2 */
   0x09, 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08,   -1,   -1 },
  {0x10, 0x84, 0x10,   -1, 0x04, 0x05, 0x0f, 0x01,   -1,          /* GIGA */
   0xf0, 0x60, 0x70, 0x80, 0x90, 0xa0, 0xb0, 0xc0, 0xd0, 0xe0,   -1,   -1 },
  {0x40, 0x81, 0x16, 0x1f, 0x54, 0x0b, 0x1d, 0x5c, 0x1c,      /* JOYSOUND */
   0x00, 0x07, 0x0a, 0x58, 0x03, 0x06, 0x50, 0x01, 0x0e, 0x5d,   -1,   -1 },
  {0x20, 0xac, 0x53, 0x9d, 0xcc, 0xca, 0x96, 0xdc, 0x9a,    /* BeMax'S /T */
   0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,   -1,   -1 },
  {0x10, 0x81, 0xb0, 0x33, 0xd3, 0xb3, 0x93, 0x13,   -1,    /* Prologue21 */
   0x00, 0x08, 0x04, 0x0c, 0x02, 0x0a, 0x06, 0x0e, 0x01, 0x09,   -1,   -1 },
  {0x10, 0xd1, 0x2d, 0x09, 0x04, 0x05, 0x00, 0x01, 0x07,           /* DAM */
   0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x3a, 0x3b },
  {0x30, 0x87, 0x56, 0x12, 0x43, 0x47, 0x11,   -1, 0x42,        /* ALISA3 */
   0x0d, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0e, 0x0f },
  {0x30, 0x87, 0x56, 0x12, 0x43, 0x47, 0x11,   -1, 0x42,        /* ALISA3 */
   0x0d, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0e, 0x0f },
  {0x30, 0x00, 0xff, 0x41, 0x08, 0x09, 0x4c, 0x45, 0x44,      /* TOEI sys */
   0x13, 0x0f, 0x4f, 0x4e, 0x07, 0x47, 0x46, 0x03, 0x43, 0x42, 0x53, 0x52 }
  };

int tsc[] = {0x00, 0x04, 0x0c, 0x10, 0x01, 0x05, 0x0d, 0x11};

char *cverrstr[] = {
  "Invalid maker code.",
  "Invalid music number.",
  "Invalid function code."
};

int cdcnv(int buf[], char *mak, char *cod)
{
  int maker, i, c, *q;

  if ((maker = (int)strchr(mks, *mak & 0xdf)) == NULL)
    return -1;
  maker -= (int)mks;

  q = buf;

  *q++ = 0x80;	/* wake-up code */
  *q++ = cvt[maker][0];
  *q++ = cvt[maker][1];
  *q++ = cvt[maker][2];

  if (*mak++ != 0) {
    if ((maker == M_AL)&&('0' <= *mak)&&(*mak <= '4'))
      cvt[maker][K_SE] = 0x12 + (*mak - '0');
    else if ((maker == M_AZ)&&('1' <= *mak)&&(*mak <= '4'))
      *q++ = 0x13 + (*mak - '1');
    else if ((maker == M_TS)&&('1' <= *mak)&&(*mak <= '8'))
      *q++ = tsc[*mak - '1'];
    else if ((maker == M_UK)&&('2' == *mak)) {
      buf[1] = 0x70;
      *q++ = 0xf0;
    }
  }

  if (('0' <= *cod)&&(*cod <= '9')) {
    if (maker == M_DA)
      *q++ = 0x08;
    while((c = *cod++) != '\0') {
      if (('0' <= c)&&(c <= '9'))
        *q = cvt[maker][c - '0' + K_NM];
      else if ((c == 'A')||(c == 'a'))
        *q = cvt[maker][10 + K_NM];
      else if ((c == 'B')||(c == 'b'))
        *q = cvt[maker][11 + K_NM];
      else if (c == '-')
        continue;
      else
        *q = -1;
      if (*q++ == -1)
	return -2;
    }
    switch(maker) {
    case M_X2:
      q -= 2;
      q[3] = cvt[maker][K_SE];
      q[2] = q[1];
      q[1] = q[0];
      q[0] = cvt[maker][K_SE];
      q += 4;
      break;
    case M_GI:
      while(q < &buf[10])
        *q++ = cvt[maker][K_NM];
      break;
    case M_PR:
      for( i=0; i<3; i++ ) {
        buf[10-i] = 0;
        if (q > &buf[4])
          buf[10-i] = *--q << 4;
        if (q > &buf[4])
          buf[10-i] |= *--q;
      }
      q = &buf[11];
      *q++ = 0x33;
      buf[4] = buf[8];
      buf[5] = buf[9];
      buf[6] = buf[10];
      buf[7] = buf[11];
      break;
    case M_DA:
      for( i=0; i<7; i++ ) {
        if ((i == 2)&&(*(q-1) <= 0x39))
          buf[11-i] = 0x3c;
        else if (q > &buf[5])
          buf[11-i] = *--q;
        else
          buf[11-i] = cvt[maker][K_NM];
      }
      q = &buf[12];
    default:
      *q++ = cvt[maker][K_SE];
      break;
    }
  }
  else {
    *q = -1;
    if (!stricmp(cod, "SE"))
      *q = cvt[maker][K_SE];
    else if (!stricmp(cod, "KU"))
      *q = cvt[maker][K_KU];
    else if (!stricmp(cod, "KD"))
      *q = cvt[maker][K_KD];
    else if (!stricmp(cod, "SP"))
      *q = cvt[maker][K_SP];
    else if (!stricmp(cod, "ST"))
      *q = cvt[maker][K_ST];
    else if (!stricmp(cod, "CL"))
      *q = cvt[maker][K_CL];
    if (*q == -1)
      return -3;
    q++;
  }
  if ((maker == M_UK)&&(buf[1] == 0x70))
    *q++ = 0xf7;
  buf[1] |= q-buf-2;
  return q-buf;
}
