/* rcctl.c -------------------------------------
  v0.10  97.08.15  (ߥå52)
  v0.11  97.08.27  ̿ߥ󥰽
  v0.12  97.09.12  U-kara-2ݡ
  v0.12a 97.09.15  ֤
  v0.12b 97.09.20  Bug fix (JOY:[SP])
  v0.20  97.10.01  FreeBSD
  v0.20a 97.10.18  Bug fix (X2k:[SP],[ST])
  v0.21  97.12.10  ALISA-3󥹽
  v0.30  97.12.13  Ѵ(cdcnv.c)ʬΥ
----------------------------------------------*/

#include <fcntl.h>
#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <sys/ioctl.h>

/* #define VERBOSE */

#ifndef DEV
#define DEV "/dev/cuaa0"
#endif

int cdcnv(int buf[], char *mak, char *cod);
extern char *cverrstr[];

int fd;

int init(void)
{
  int tcnt = 0;
  struct termios tios;
  int md;

  if ((fd = open(DEV, O_RDWR)) == -1) {
    fprintf(stderr, "Cannot open %s.\n", DEV);
    return 255;
  }

  tcgetattr(fd, &tios);
  tios.c_iflag = 0;
  tios.c_oflag = 0;
  tios.c_cflag = B9600|CS8|CLOCAL;
  tios.c_lflag = 0;
/*
  cfmakeraw(&tios);
  cfsetspeed(&tios, B9600);
*/
  tcsetattr(fd, TCSANOW, &tios);
  tcflush(fd, TCOFLUSH);

  md = TIOCM_LE|TIOCM_DTR|TIOCM_RTS;
  ioctl(fd, TIOCMBIS, &md);

  /* wait for CTS: Ԥ */
  for(;;) {
    ioctl(fd, TIOCMGET, &md);
    if (md & TIOCM_CTS)
      break;
    if (tcnt == 0) {
      fprintf(stderr, "Waiting....");
    }
    if (tcnt++ >= 40) {
      fprintf(stderr, "Device timeout.\n");
      close(fd);
      return 1;
    }
    sleep(1);
  }

  md = TIOCM_RTS;
  ioctl(fd, TIOCMBIC, &md);
  usleep(10000);	/* 10ms */
  ioctl(fd, TIOCMBIS, &md);
  usleep(50000);	/* 50ms */

  return 0;
}

/* CTS  0.5 ðʾϢ³ ON ˤʤޤԤ */
void charge(void)
{
  int i, md;

  for( i=0; i<50; i++ ) {
    usleep(10000);	/* 10ms */
    ioctl(fd, TIOCMGET, &md);
    if (!(md & TIOCM_CTS))
      i = 0;
  }
}

int main(int ac, char *av[])
{
  int i, u, buf[16];

  if (ac < 3) {
    printf("Usage: rcctl <maker> <code>\n");
    return 255;
  }

  if ((u = cdcnv(buf, av[1], av[2])) < 0) {
    fprintf(stderr, "%s: %s\n", av[0], cverrstr[~u]);
    return 1;
  }

#ifdef VERBOSE
  printf("Initializing....");
#endif
  if (init())
    return 255;
#ifdef VERBOSE
  printf(" done.\n");
#endif
/*
  if ((maker == M_UK)&&((buf[1] & 0xf0) == 0x70))
    sleep(20);
*/
  write(fd, buf, 1);
  usleep(50000);	/* 50ms */
#ifdef VERBOSE
/*
  printf("maker %d (%c).\n", maker, mks[maker]);
*/
  for(i=0; i<u; i++ ) {
    printf("%02x ", buf[i]);
  }
  printf("\n");
#endif
  for(i=1; i<u; i++ ) {
    write(fd, &buf[i], 1);
  }

  charge();
  close(fd);
  return 0;
}
