/* rcctl.c -------------------------------------
  v0.10  97.08.15  (R~Pbg52)
  v0.11  97.08.27  ʐM^C~OC
  v0.12  97.09.12  U-kara-2T|[g
  v0.12a 97.09.15  Ԃlݒ
  v0.12b 97.09.20  Bug fix (JOY:[SP])
  v0.20  97.10.02  PC-98x1
  v0.30  97.12.13  R[hϊ(cdcnv.c)
----------------------------------------------*/

#include <dos.h>
#include <stdio.h>
#include <string.h>

#ifdef LSI_C
#include <machine.h>
#endif

/* #define VERBOSE */

/* PC-9801 definitions */
#define P_DAT 0x30  /* 8251: data */
#define P_CMD 0x32  /* 8251: cmd/stat */
#define P_MDM 0x33  /* modem status */
#define P_WAT 0x5f  /* wait 600us */
#define P_TMC 0x77  /* 8253: command */
#define P_TM2 0x75  /* 8253: timer 2 */

#define B_CTS 0x40
#define B_DTR 0x02
#define B_RTS 0x20
#define B_TXR 0x01

#define C_RES 0x40  /* 8251CMD: reset */
#define C_INI 0x4e  /* 8251CMD: mode '8N1'*/
#define C_CMD 0x15  /* 8251CMD: command */

int cdcnv(int buf[], char *mak, char *cod);
extern char *cverrstr[];

int sioc;

int init(void)
{
  int tcnt = 0;

  outp(P_TMC, 0xb6);
  outp(P_WAT, 0);
  outp(P_TM2, (*(char far *)0x00000501L & 0x80)? 13: 16);
  outp(P_WAT, 0);
  outp(P_TM2, 0);

  outp(P_CMD, 0);
  outp(P_WAT, 0);
  outp(P_CMD, 0);
  outp(P_WAT, 0);
  outp(P_CMD, 0);
  outp(P_WAT, 0);
  outp(P_CMD, C_RES);
  outp(P_WAT, 0);
  outp(P_CMD, C_INI);
  outp(P_WAT, 0);
  outp(P_CMD, (sioc = C_CMD|B_DTR));
  outp(P_WAT, 0);

  /* wait for CTS */
  while(inp(P_MDM) & B_CTS) {
    if (tcnt == 0) {
      fprintf(stderr, "Waiting....");
    }
    if (tcnt++ >= 40) {
      fprintf(stderr, "Device timeout.\n");
      return 1;
    }
    sleep(1);
  }

  outp(P_CMD, (sioc &= ~B_RTS));	/* !RTS (for MCLR) */
  delay(10);	/* wait 10ms */
  outp(P_CMD, (sioc |=  B_RTS));	/* RTS */
  delay(50);	/* wait 50ms */

  return 0;
}

/* CTS  0.5 bȏA ON ɂȂ܂ő҂ */
void charge(void)
{
  int i;

  for( i=0; i<50; i++ ) {
    delay(10);	/* 10ms */
    if(inp(P_MDM) & B_CTS)
      i = 0;
  }
}

void sendc(int c)
{
  while(!(inp(P_CMD) & B_TXR));	/* TxRDY */
  outp(P_DAT, c);
}

int main(int ac, char *av[])
{
  int i, u, buf[16];

  if (ac < 3) {
    printf("Usage: rcctl <maker> <code>\n");
    return 255;
  }

  if ((u = cdcnv(buf, av[1], av[2])) < 0) {
    fprintf(stderr, "%s: %s\n", av[0], cverrstr[~u]);
    return 1;
  }

#ifdef VERBOSE
  printf("Initializing....");
#endif
  if (init())
    return 255;
#ifdef VERBOSE
  printf(" done.\n");
#endif

  sendc(buf[0]);
  delay(50);
#ifdef VERBOSE
/*
  printf("maker %d (%c).\n", maker, mks[maker]);
*/
  for(i=0; i<u; i++ ) {
    printf("%02x ", buf[i]);
  }
  printf("\n");
#endif
  for(i=1; i<u; i++ ) {
    sendc(buf[i]);
  }

  charge();
  return 0;
}

