/* rcctl.c -------------------------------------
  v0.10  97.08.15  (R~Pbg52)
  v0.11  97.08.27  ʐM^C~OC
  v0.12  97.09.12  U-kara-2T|[g
  v0.12a 97.09.15  Ԃlݒ
  v0.12b 97.09.20  Bug fix (JOY:[SP])
  v0.30  97.12.13  R[hϊ(cdcnv.c)
----------------------------------------------*/

#include <dos.h>
#include <stdio.h>
#include <string.h>

#ifdef LSI_C
#include <machine.h>
#endif

/* #define VERBOSE */

/* 8250 registers */
#define RBR 0x00	
#define THR 0x00	/*  w: TxDATA */
#define IER 0x01	/* rw: IntEnb */
#define IIR 0x02
#define LCR 0x03	/* rw: LineCtl */
#define MCR 0x04	/* rw: ModemCtl */
#define LSR 0x05	/* r : LineStat */
#define MSR 0x06	/* r : ModemStat */
#define DLL 0x00	/* rw: DivLatch L */
#define DLH 0x01	/* rw: DivLatch H */

int cdcnv(int buf[], char *mak, char *cod);
extern char *cverrstr[];

int pbase;

void sleep100(int c)
{
  int d;

#ifdef __TURBOC__
  struct time u, t;
  gettime(&u);
  do {
    gettime(&t);
    d = (t.ti_hund + t.ti_sec*100) - (u.ti_hund + u.ti_sec*100);
#else
  struct dostime_t u, t;
  _dos_gettime(&u);
  do {
    _dos_gettime(&t);
    d = (t.hsecond + t.second*100) - (u.hsecond + u.second*100);
#endif
    if (d < 0)
      d += 6000;
  } while(d <= c);
}

int init(void)
{
  int tcnt = 0;
  pbase = *(int far *)0x00400000L;	/* COM1 */

  outp(pbase+LCR, 0x83);	/* N81 */
  outp(pbase+DLL,   12);	/* 9600bps */
  outp(pbase+DLH,    0);
  outp(pbase+LCR, 0x03);
  outp(pbase+IER, 0x00);	/* disable */
  outp(pbase+MCR, 0x03);	/* DTR,RTS */

  /* wait for CTS */
  while(!(inp(pbase+MSR) & 0x10)) {
    if (tcnt == 0) {
      fprintf(stderr, "Waiting....");
    }
    if (tcnt++ >= 40) {
      fprintf(stderr, "Device timeout.\n");
      return 1;
    }
    sleep(1);
  }

  outp(pbase+MCR, 0x01);	/* !RTS (for MCLR) */
  sleep100(1);	/* wait 10ms */
  outp(pbase+MCR, 0x03);	/* RTS */
  sleep100(5);	/* wait 50ms */

  return 0;
}

/* CTS  0.5 bȏA ON ɂȂ܂ő҂ */
void charge(void)
{
  int i;

  for( i=0; i<50; i++ ) {
    sleep100(1);	/* 10ms */
    if(!(inp(pbase+MSR) & 0x10))
      i = 0;
  }
}

void sendc(int c)
{
  while(!(inp(pbase+LSR) & 0x20));	/* THRE */
  outp(pbase+THR, c);
}

int main(int ac, char *av[])
{
  int i, u, buf[16];

  if (ac < 3) {
    printf("Usage: rcctl <maker> <code>\n");
    return 255;
  }

  if ((u = cdcnv(buf, av[1], av[2])) < 0) {
    fprintf(stderr, "%s: %s\n", av[0], cverrstr[~u]);
    return 1;
  }

#ifdef VERBOSE
  printf("Initializing....");
#endif
  if (init())
    return 255;
#ifdef VERBOSE
  printf(" done.\n");
#endif

  sendc(buf[0]);
  sleep100(5);
#ifdef VERBOSE
/*
  printf("maker %d (%c).\n", maker, mks[maker]);
*/
  for(i=0; i<u; i++ ) {
    printf("%02x ", buf[i]);
  }
  printf("\n");
#endif
  for(i=1; i<u; i++ ) {
    sendc(buf[i]);
  }

  charge();
  return 0;
}

